{$A+,B-,D+,E-,F+,G+,I-,L+,N+,O-,R-,S-,V-}

UNIT ObjPoints;

INTERFACE

USES Maths,Basis;

CONST oInfinite=1e8;

TYPE ObjectPoint=RECORD
         l:RealType;
         n:Vector3;
         obj:POINTER
     END;

CONST infinitePoint:ObjectPoint=(l:oInfinite;n:(x:1;y:0;z:0);obj:NIL);
      ninfinitePoint:ObjectPoint=(l:-oInfinite;n:(x:1;y:0;z:0);obj:NIL);

PROCEDURE CopyInverse(VAR o,p:ObjectPoint);

IMPLEMENTATION

(*$IFOPT N-*)

PROCEDURE CopyInverse(VAR o,p:ObjectPoint);
BEGIN
    o.l:=p.l;
    o.n.x:=-p.n.x;
    o.n.y:=-p.n.y;
    o.n.z:=-p.n.z;
    o.obj:=p.obj
END;

(*$ELSE*)

PROCEDURE CopyInverse(VAR o,p:ObjectPoint);
ASSEMBLER;
ASM
                            (*  ST  |  1   |  2   |  3   |  4   |  5   |  6   |  7   *)
    LES DI,p
    FLD DWORD PTR ES:[DI]   (* p.l  |      |      |      |      |      |      |      *)
    FLD DWORD PTR ES:[DI+4] (* p.n.x| p.l  |      |      |      |      |      |      *)
    FCHS                    (*-p.n.x| p.l  |      |      |      |      |      |      *)
    FLD DWORD PTR ES:[DI+8] (* p.n.y|-p.n.x| p.l  |      |      |      |      |      *)
    FCHS                    (*-p.n.y|-p.n.x| p.l  |      |      |      |      |      *)
    FLD DWORD PTR ES:[DI+12](* p.n.z|-p.n.y|-p.n.x| p.l  |      |      |      |      *)
    FCHS                    (*-p.n.z|-p.n.y|-p.n.x| p.l  |      |      |      |      *)
    MOV AX,WORD PTR ES:[DI+16]
    MOV BX,WORD PTR ES:[DI+18]
    LES DI,o
    MOV WORD PTR ES:[DI+16],AX
    MOV WORD PTR ES:[DI+18],BX
    FSTP DWORD PTR ES:[DI+12]
    FSTP DWORD PTR ES:[DI+8]
    FSTP DWORD PTR ES:[DI+4]
    FSTP DWORD PTR ES:[DI]
    FWAIT

END;

(*$ENDIF*)


END.
